<?php
/***********************************************************
	Filename: app/admin/control/cate.php
	Note	: 产品分类管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class cate_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("cate");
	}

	function cate_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("cate:list","tpl");//查看权限
		$rslist = $this->cate_m->get_all();//取得所有店铺
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("cate/list.html");
	}

	function set_f()
	{
		$id = $this->trans_lib->int("id");
		if($id)
		{
			sys_popedom("cate:modify","tpl");
			$this->tpl->assign("id",$id);
			$rs = $this->cate_m->get_one($id);
			$this->tpl->assign("rs",$rs);
		}
		else
		{
			sys_popedom("cate:add","tpl");
		}
		$this->load_model("admin");
		$adminlist = $this->admin_m->get_admin_not_system();
		$this->tpl->assign("adminlist",$adminlist);
		$this->tpl->display("cate/set.html");
	}

	function setok_f()
	{
		$array = array();
		$id = $this->trans_lib->int("id");
		$id ? sys_popedom("cate:modify","tpl") : sys_popedom("cate:add","tpl");
		$catename = $this->trans_lib->safe("catename");
		$backurl = $id ? $this->url("cate,set","id=".$id) : $this->url("cate,set");
		if(!$catename)
		{
			error("请填写分类名称",$backurl);
		}
		$array["catename"] = $catename;
		$array["taxis"] = $this->trans_lib->int("taxis");
		$array["status"] = $this->trans_lib->int("status");
		$array["ifprint"] = $this->trans_lib->int("ifprint");
		$this->cate_m->save($array,$id);
		$a_e = $id ? "编辑" : "添加";
		error("分类名称信息".$a_e."成功！",$this->url("cate"));
	}

	function del_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("cate:del","ajax");
		$this->cate_m->del($id);
		exit("ok");
	}
}
?>