<?php
/***********************************************************
	Filename: app/admin/control/expense_list.php
	Note	: 店铺管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class expense_list_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("expense");
		$this->load_model("shop");
		$this->load_model("admin");
		$this->load_model("elder");
	}

	function expense_list_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("expense1:list","tpl");//查看权限
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		//判断是否是系统管理员
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$pageurl = $this->url("expense");
		if(!$admin_rs["if_system"])
		{
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist AS $key=>$value)
			{
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"])))
				{
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1)
			{
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
			unset($tmp_shoplist);
		}
		$this->tpl->assign("shoplist",$shoplist);
		//获取年信息
		$tmplist = $this->expense_m->year_group();
		$yearlist = array();
		if($tmplist)
		{
			foreach($tmplist AS $key=>$value)
			{
				$yearlist[] = $value["years"];
			}
		}
		$this->tpl->assign("yearlist",$yearlist);
		$this->tpl->display("expense/index.html");
	}
}
?>