<?php
/***********************************************************
	Filename: app/admin/control/print.php
	Note	: 打印管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class print_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("shop");
		$this->load_model("elder");
		$this->load_model("expense");
		$this->load_model("admin");
		$this->load_model("cate");
	}

	function print_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("print:print","tpl");//查看权限
		$shoplist = $this->shop_m->get_all();//取得所有店铺
		if(!$shoplist)
		{
			error("未设置分院");
		}
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		if(!$admin_rs["if_system"])
		{
			$tmp_shop_id = 0;
			$tmp_shoplist = array();
			foreach($shoplist AS $key=>$value)
			{
				if($value["admin_name"] && in_array($_SESSION["admin_name"],explode(",",$value["admin_name"])))
				{
					$tmp_shop_id = $value["id"];
					$tmp_shoplist[] = $value;
				}
			}
			if(!$tmp_shop_id)
			{
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
		}
		$this->tpl->assign("shoplist",$shoplist);
		//获取年信息
		$tmplist = $this->expense_m->year_group();
		$yearlist = array();
		if($tmplist)
		{
			foreach($tmplist AS $key=>$value)
			{
				$yearlist[] = $value["years"];
			}
		}
		$this->tpl->assign("yearlist",$yearlist);
		$urlext = SYS_SESSION_ID.'='.session_id();
		$this->tpl->assign('urlext',$urlext);

		$this->tpl->display("print/index.html");
	}

	function printlist_f()
	{
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$condition = "1=1";
		$shopid = $this->trans_lib->int("shopid");
		if(!$shopid)
		{
			exit("error：没有指定分院");
		}
		$condition .= " AND e.shopid='".$shopid."'";
		$shop_rs = $this->shop_m->get_one($shopid);
		if(!$shop_rs)
		{
			exit("error：无法找到相关分院信息");
		}
		$this->tpl->assign("shop_rs",$shop_rs);
		//取得老人信息
		$condition .= " AND e.lifestatus='生存'";
		$total = $this->elder_m->get_count($condition);
		$rslist = $this->elder_m->get_list($condition,0,$total);
		if(!$rslist)
		{
			exit("error：老人信息为空！");
		}
		//取得产品分类
		$catelist = $this->cate_m->get_all("ifprint='1' AND status='1'");
		if(!$catelist)
		{
			$this->tpl->assign("catelist",array());
		}
		else{
			$this->tpl->assign("catelist",$catelist);
		}
		
		//判断时间
		$expense_year = $this->trans_lib->safe("expense_year");
		$expense_month = $this->trans_lib->safe("expense_month");
		if(!$expense_year || !$expense_month)
		{
			exit("error：年月时间为空");
		}
		$my_expense_month = $expense_month < 10 ? "0".$expense_month : $expense_month;
		$year_month = $expense_year."/".$my_expense_month;
		$total = 0;
		foreach($rslist AS $key=>$value)
		{
			foreach($catelist As $k=>$v)
			{
				$rslist[$key]["ext_".$v["id"]] = $this->expense_m->get_total_price($value["id"],$v["id"],$year_month);
			}
			$total++;
		}
		$this->tpl->assign("year_month",$year_month);
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->assign("total",$total);
		$tplfile = $this->trans_lib->safe("tplfile");
		$excel = $this->trans_lib->int('excel');
		if($excel){
			header("Content-type:application/vnd.ms-excel");
			header("Content-Disposition:attachment;filename=".date("Ymd")."-".$_SESSION['admin_id']."-elder.xls");
		}
		$this->tpl->display("print/elder_ext_list.html");
	}
}
?>