<?php
/***********************************************************
	Filename: app/admin/control/products.php
	Note	: 店铺管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class products_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("products");
		$this->load_model("cate");
	}

	function products_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("products:list","tpl");//查看权限
		$catelist = $this->cate_m->get_all();//取得所有分类
		$this->tpl->assign("catelist",$catelist);
		$pageid = $this->trans_lib->int(SYS_PAGEID);
		$psize = defined("SYS_PSIZE") ? SYS_PSIZE : 30;
		$pageurl = $this->url("products");
		$cateid = $this->trans_lib->int("cateid");
		$keywords = $this->trans_lib->safe("keywords");
		$this->tpl->assign("keywords",$keywords);
		$this->tpl->assign("cateid",$cateid);
		$pageurl .= "cateid=".$cateid."&keywords=".rawurlencode($keywords);
		$rslist = $this->products_m->get_list($cateid,$keywords,$pageid,$psize);//取得产品列表
		$total = $this->products_m->get_count($cateid,$keywords);
		$this->page_lib->set_psize($psize);
		$pagelist = $this->page_lib->page($pageurl,$total);
		if($pagelist)
		{
			$this->tpl->assign("pagelist",$pagelist);
		}
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("products/list.html");
	}

	function set_f()
	{
		$catelist = $this->cate_m->get_all();//取得所有分类
		$this->tpl->assign("catelist",$catelist);
		$id = $this->trans_lib->int("id");
		if($id)
		{
			sys_popedom("products:modify","tpl");
			$this->tpl->assign("id",$id);
			$rs = $this->products_m->get_one($id);
			$this->tpl->assign("rs",$rs);
		}
		else
		{
			sys_popedom("products:add","tpl");
		}
		$this->tpl->display("products/set.html");
	}

	function setok_f()
	{
		$array = array();
		$id = $this->trans_lib->int("id");
		$id ? sys_popedom("products:modify","tpl") : sys_popedom("products:add","tpl");
		$title = $this->trans_lib->safe("title");
		$backurl = $id ? $this->url("products,set","id=".$id) : $this->url("products,set");
		if(!$title)
		{
			error("请填写产品名称",$backurl);
		}
		$array["title"] = $title;
		$array["cateid"] = $this->trans_lib->int("cateid");
		$array["price"] = $this->trans_lib->float("price");
		if(!$id)
		{
			$array["status"] = $this->trans_lib->int("status");
		}
		$this->products_m->save($array,$id);
		$a_e = $id ? "编辑" : "添加";
		error("产品信息".$a_e."成功！",$this->url("products"));
	}

	function del_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("products:del","ajax");
		$this->products_m->del($id);
		exit("ok");
	}

	function taxis_f()
	{
		$id = $this->trans_lib->int("id");
		$taxis = $this->trans_lib->int("taxis");
		if(!$id)
		{
			exit("没有指定产品ID");
		}
		$array = array();
		$array["taxis"] = $taxis;
		$this->products_m->save($array,$id);
		exit("ok");
	}

	function status_f()
	{
		$id = $this->trans_lib->int("id");
		$status = $this->trans_lib->int("status");
		if(!$id)
		{
			exit("没有指定产品ID");
		}
		$array = array();
		$array["status"] = $status;
		$this->products_m->save($array,$id);
		exit("ok");
	}
}
?>