<?php
/***********************************************************
	Filename: app/admin/control/shop.php
	Note	: 店铺管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class shop_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("shop");
	}

	function shop_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("shop:list","tpl");//查看权限
		$rslist = $this->shop_m->get_all();//取得所有店铺
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("shop/list.html");
	}

	function set_f()
	{
		$id = $this->trans_lib->int("id");
		if($id)
		{
			sys_popedom("shop:modify","tpl");
			$this->tpl->assign("id",$id);
			$rs = $this->shop_m->get_one($id);
			$this->tpl->assign("rs",$rs);
		}
		else
		{
			sys_popedom("shop:add","tpl");
		}
		$this->load_model("admin");
		$adminlist = $this->admin_m->get_admin_not_system();
		$this->tpl->assign("adminlist",$adminlist);
		$this->tpl->display("shop/set.html");
	}

	function setok_f()
	{
		$array = array();
		$id = $this->trans_lib->int("id");
		$id ? sys_popedom("shop:modify","tpl") : sys_popedom("shop:add","tpl");
		$shopname = $this->trans_lib->safe("shopname");
		$backurl = $id ? $this->url("shop,set","id=".$id) : $this->url("shop,set");
		if(!$shopname)
		{
			error("请填写院名",$backurl);
		}
		$array["shopname"] = $shopname;
		$array["admin_name"] = $this->trans_lib->safe("admin_name");
		$array["tel"] = $this->trans_lib->safe("tel");
		$array["address"] = $this->trans_lib->safe("address");
		$array["mobile"] = $this->trans_lib->safe("mobile");
		$array["zipcode"] = $this->trans_lib->safe("zipcode");
		$array["status"] = $this->trans_lib->int("status");
		$array["bedcount"] = $this->trans_lib->int("bedcount");
		$this->shop_m->save($array,$id);
		$a_e = $id ? "编辑" : "添加";
		error("分院信息".$a_e."成功！",$this->url("shop"));
	}

	function del_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("shop:del","ajax");
		$this->shop_m->del($id);
		exit("ok");
	}
}
?>