<?php

/***********************************************************

	Filename: app/admin/models/products.php

	Note	: 产品管理功能

	Version : 3.0

	Author  : qinggan

	Update  : 2010-12-19

***********************************************************/

class products_m extends Model

{

	function __construct()

	{

		parent::Model();

	}



	function products_m()

	{

		$this->__construct();

	}



	function get_one($id)

	{

		if(!$id)

		{

			return false;

		}

		$sql = "SELECT * FROM ".$this->db->prefix."products WHERE id='".$id."'";

		$rs = $this->db->get_one($sql);

		if(!$rs)

		{

			return false;

		}

		return $rs;

	}



	function get_list($cateid=0,$keywords="",$pageid=0,$psize=20)

	{

		$sql = "SELECT p.*,c.catename FROM ".$this->db->prefix."products p LEFT JOIN ".$this->db->prefix."cate c ON(p.cateid=c.id) ";

		$sql.= " WHERE 1=1 ";

		if($cateid)

		{

			$sql .= " AND p.cateid='".$cateid."'";

		}

		if($keywords)

		{

			$sql .= " AND p.title LIKE '%".$keywords."%' ";

		}

		$offset = $pageid>0 ? ($pageid-1) * $psize : 0;

		$sql .= " ORDER BY p.taxis ASC,p.id DESC LIMIT ".$offset.",".$psize;

		return $this->db->get_all($sql);

	}



	function get_all()

	{

		$sql = "SELECT p.*,c.catename FROM ".$this->db->prefix."products p LEFT JOIN ".$this->db->prefix."cate c ON(p.cateid=c.id) ";

		$sql.= " WHERE p.status='1'";

		$sql .= " ORDER BY p.taxis ASC,p.id DESC";

		return $this->db->get_all($sql);

	}



	function get_count($cateid=0,$keywords="")

	{

		$sql = "SELECT count(p.id) FROM ".$this->db->prefix."products p LEFT JOIN ".$this->db->prefix."cate c ON(p.cateid=c.id) ";

		$sql.= " WHERE 1=1 ";

		if($cateid)

		{

			$sql .= " AND p.cateid='".$cateid."'";

		}

		if($keywords)

		{

			$sql .= " AND p.title LIKE '%".$keywords."%' ";

		}

		return $this->db->count($sql);

	}



	//存储数据

	function save($data,$id=0)

	{

		if($id)

		{

			$this->db->update_array($data,"products",array("id"=>$id));

			return true;

		}

		else

		{

			$insert_id = $this->db->insert_array($data,"products");

			return $insert_id;

		}

	}



	function del($id)

	{

		$sql = "DELETE FROM ".$this->db->prefix."products WHERE id='".$id."'";

		return $this->db->query($sql);

	}

}

?>